---
title: 'Document: visibilitychange event'
slug: Web/API/Document/visibilitychange_event
tags:
  - API
  - Document
  - Event
  - Reference
  - Visibility
  - Web
  - visibilitychange
---
<div>{{APIRef}}</div>

<p>The <code>visibilitychange</code> event is fired at the document when the content of its tab have become visible or have been hidden.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("Event")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{domxref("Document.onvisibilitychange", "onvisibilitychange")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Usage_notes">Usage notes</h2>

<p>The event doesn't include the document's updated visibility status, but you can get that information from the document's {{domxref("Document.visibilityState", "visibilityState")}} property.</p>

<div class="notecard warning">
<p>Safari doesn’t fire <code>visibilitychange</code> as expected when the value of the <code><a href="/en-US/docs/Web/API/Document/visibilityState">visibilityState</a></code> property transitions to <code>hidden</code>; so for that case, you need to also include code to listen for the <code><a href="/en-US/docs/Web/API/Window/pagehide_event">pagehide</a></code> event.</p>
</div>

<div class="notecard warning">
<p>For compatibility reasons, make sure to use <code>document.addEventListener</code> to register the callback and not <code>window.addEventListener</code>. Safari &lt; 14.0 only supports the former.</p>
</div>

<h2 id="Examples">Examples</h2>

<p>This example begins playing a music track when the document becomes visible, and pauses the music when the document is no longer visible.</p>

<pre class="brush:js notranslate">document.addEventListener("visibilitychange", function() {
  if (document.visibilityState === 'visible') {
    backgroundMusic.play();
  } else {
    backgroundMusic.pause();
  }
});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Page Visibility API','#dfn-visibilitychange','visibilitychange')}}</td>
   <td>{{Spec2('Page Visibility API')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Document.visibilitychange_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Page_Visibility_API">Page Visibility API</a></li>
 <li>{{domxref("Document.visibilityState")}}</li>
</ul>
